close all;
clear all;


%Filter coefficients 
Hp=[-0.2304 0.7148 -0.6309 -0.0280 0.1870 0.0308 -0.0329 -0.0106]; %HP-Filter in floating-point format

%Integer Precision
Hp16 = [-347 -1078 1009 6128 -918 -20673 23423 -7550]; %fixed-point-format 16-bit
Hp32 = [-22763327 -70652212 66142496 401579442 -60129542 -1354847434 1535021312 -494780233];%fixed-point-format 32-bit

%the signal is a segment of 16 sec 
load testsignal.mat;
s= testsignal';
s = s(1,:)-2048; %mapping into micro-volt range
s = (s(1,:)*250)/2048;

T = 16; %sec
N = length(s);
l = N + length(Lo1) - 1; %gives the length of the output from convolution operation  

%frequency response of signal
HP = fft(Hp,l);
HP16 = fft(Hp16,l);
HP32 = fft(Hp32,l);
A =abs(HP(1:N/2));
A16 = abs(HP16(1:N/2));
A32 = abs(HP32(1:N/2));

% A =abs(HP(1:N/2))/max(max(abs(HP(1:N/2))));
% 
% A16 = abs(HP16(1:N/2))/max(max(abs(HP16(1:N/2))));
% A32 = abs(HP32(1:N/2))/max(max(abs(HP32(1:N/2))));

freq = (0:(N/2)-1)/T;
figure
plot(freq,A,'r.-');
xlim([0 500]);
title('Frequency response of HP-Filter')
xlabel('f [Hz]')
ylabel('Magnitude')
grid on
% hold on
figure

plot(freq,A_32,'b.-');
xlim([0 500]);
title('Frequency response of HP-Filter')
xlabel('f [Hz]')
ylabel('Magnitude')
grid on

%%Vorschlag von Detlev

x=A(:);
y1=A16(:);
y2=A32(:);
M=[x ones(length(x),1)];
coef16=inv(M'*M)*M'*y1;
coef32=inv(M'*M)*M'*y2;
figure 
plot(M*coef16-y1,'r')
grid on
figure 
plot(M*coef32-y2,'b')
grid on
